import spaceTrim, { spaceTrim as spaceTrim$1 } from 'spacetrim';

// ⚠️ WARNING: This code has been generated so that any manual changes will be overwritten
/**
 * The version of the Promptbook library
 */
var PROMPTBOOK_VERSION = '0.72.0-6';
// TODO: [main] !!!! List here all the versions and annotate + put into script

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

/**
 * This error indicates that the promptbook in a markdown format cannot be parsed into a valid promptbook object
 *
 * @public exported from `@promptbook/core`
 */
var ParseError = /** @class */ (function (_super) {
    __extends(ParseError, _super);
    function ParseError(message) {
        var _this = _super.call(this, message) || this;
        _this.name = 'ParseError';
        Object.setPrototypeOf(_this, ParseError.prototype);
        return _this;
    }
    return ParseError;
}(Error));
/**
 * TODO: Maybe split `ParseError` and `ApplyError`
 */

/**
 * Makes first letter of a string uppercase
 *
 * @public exported from `@promptbook/utils`
 */
function capitalize(word) {
    return word.substring(0, 1).toUpperCase() + word.substring(1);
}

/**
 * Extracts all code blocks from markdown.
 *
 * Note: There are multiple simmilar function:
 * - `extractBlock` just extracts the content of the code block which is also used as build-in function for postprocessing
 * - `extractJsonBlock` extracts exactly one valid JSON code block
 * - `extractOneBlockFromMarkdown` extracts exactly one code block with language of the code block
 * - `extractAllBlocksFromMarkdown` extracts all code blocks with language of the code block
 *
 * @param markdown any valid markdown
 * @returns code blocks with language and content
 * @throws {ParseError} if block is not closed properly
 * @public exported from `@promptbook/markdown-utils`
 */
function extractAllBlocksFromMarkdown(markdown) {
    var e_1, _a;
    var codeBlocks = [];
    var lines = markdown.split('\n');
    // Note: [0] Ensure that the last block notated by gt > will be closed
    lines.push('');
    var currentCodeBlock = null;
    try {
        for (var lines_1 = __values(lines), lines_1_1 = lines_1.next(); !lines_1_1.done; lines_1_1 = lines_1.next()) {
            var line = lines_1_1.value;
            if (line.startsWith('> ') || line === '>') {
                if (currentCodeBlock === null) {
                    currentCodeBlock = { blockNotation: '>', language: null, content: '' };
                } /* not else */
                if (currentCodeBlock.blockNotation === '>') {
                    if (currentCodeBlock.content !== '') {
                        currentCodeBlock.content += '\n';
                    }
                    currentCodeBlock.content += line.slice(2);
                }
            }
            else if (currentCodeBlock !== null && currentCodeBlock.blockNotation === '>' /* <- Note: [0] */) {
                codeBlocks.push(currentCodeBlock);
                currentCodeBlock = null;
            }
            /* not else */
            if (line.startsWith('```')) {
                var language = line.slice(3).trim() || null;
                if (currentCodeBlock === null) {
                    currentCodeBlock = { blockNotation: '```', language: language, content: '' };
                }
                else {
                    if (language !== null) {
                        throw new ParseError("".concat(capitalize(currentCodeBlock.language || 'the'), " code block was not closed and already opening new ").concat(language, " code block"));
                    }
                    codeBlocks.push(currentCodeBlock);
                    currentCodeBlock = null;
                }
            }
            else if (currentCodeBlock !== null && currentCodeBlock.blockNotation === '```') {
                if (currentCodeBlock.content !== '') {
                    currentCodeBlock.content += '\n';
                }
                currentCodeBlock.content += line.split('\\`\\`\\`').join('```') /* <- TODO: Maybe make propper unescape */;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (lines_1_1 && !lines_1_1.done && (_a = lines_1.return)) _a.call(lines_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (currentCodeBlock !== null) {
        throw new ParseError("".concat(capitalize(currentCodeBlock.language || 'the'), " code block was not closed at the end of the markdown"));
    }
    return codeBlocks;
}
/**
 * TODO: Maybe name for `blockNotation` instead of  '```' and '>'
 */

/**
 * Extracts exactly ONE code block from markdown.
 *
 * - When there are multiple or no code blocks the function throws a `ParseError`
 *
 * Note: There are multiple simmilar function:
 * - `extractBlock` just extracts the content of the code block which is also used as build-in function for postprocessing
 * - `extractJsonBlock` extracts exactly one valid JSON code block
 * - `extractOneBlockFromMarkdown` extracts exactly one code block with language of the code block
 * - `extractAllBlocksFromMarkdown` extracts all code blocks with language of the code block
 *
 * @param markdown any valid markdown
 * @returns code block with language and content
 * @public exported from `@promptbook/markdown-utils`
 * @throws {ParseError} if there is not exactly one code block in the markdown
 */
function extractOneBlockFromMarkdown(markdown) {
    var codeBlocks = extractAllBlocksFromMarkdown(markdown);
    if (codeBlocks.length !== 1) {
        throw new ParseError(spaceTrim(function (block) { return "\n                    There should be exactly 1 code block in template, found ".concat(codeBlocks.length, " code blocks\n\n                    ").concat(block(codeBlocks.map(function (block, i) { return "Block ".concat(i + 1, ":\n").concat(block.content); }).join('\n\n\n')), "\n                "); }));
    }
    return codeBlocks[0];
}
/***
 * TODO: [🍓][🌻] Decide of this is internal utility, external util OR validator/postprocessor
 */

/**
 * Extracts code block from markdown.
 *
 * - When there are multiple or no code blocks the function throws a `ParseError`
 *
 * Note: There are multiple simmilar function:
 * - `extractBlock` just extracts the content of the code block which is also used as build-in function for postprocessing
 * - `extractJsonBlock` extracts exactly one valid JSON code block
 * - `extractOneBlockFromMarkdown` extracts exactly one code block with language of the code block
 * - `extractAllBlocksFromMarkdown` extracts all code blocks with language of the code block
 *
 * @public exported from `@promptbook/markdown-utils`
 * @throws {ParseError} if there is not exactly one code block in the markdown
 */
function extractBlock(markdown) {
    var content = extractOneBlockFromMarkdown(markdown).content;
    return content;
}

/**
 * Function isValidJsonString will tell you if the string is valid JSON or not
 *
 * @public exported from `@promptbook/utils`
 */
function isValidJsonString(value /* <- [👨‍⚖️] */) {
    try {
        JSON.parse(value);
        return true;
    }
    catch (error) {
        if (!(error instanceof Error)) {
            throw error;
        }
        if (error.message.includes('Unexpected token')) {
            return false;
        }
        return false;
    }
}

/**
 * Extracts  extracts exactly one valid JSON code block
 *
 * - When given string is a valid JSON as it is, it just returns it
 * - When there is no JSON code block the function throws a `ParseError`
 * - When there are multiple JSON code blocks the function throws a `ParseError`
 *
 * Note: It is not important if marked as ```json BUT if it is VALID JSON
 * Note: There are multiple simmilar function:
 * - `extractBlock` just extracts the content of the code block which is also used as build-in function for postprocessing
 * - `extractJsonBlock` extracts exactly one valid JSON code block
 * - `extractOneBlockFromMarkdown` extracts exactly one code block with language of the code block
 * - `extractAllBlocksFromMarkdown` extracts all code blocks with language of the code block
 *
 * @public exported from `@promptbook/markdown-utils`
 * @throws {ParseError} if there is no valid JSON block in the markdown
 */
function extractJsonBlock(markdown) {
    if (isValidJsonString(markdown)) {
        return markdown;
    }
    var codeBlocks = extractAllBlocksFromMarkdown(markdown);
    var jsonBlocks = codeBlocks.filter(function (_a) {
        var content = _a.content;
        return isValidJsonString(content);
    });
    if (jsonBlocks.length === 0) {
        throw new Error('There is no valid JSON block in the markdown');
    }
    if (jsonBlocks.length > 1) {
        throw new Error('There are multiple JSON code blocks in the markdown');
    }
    return jsonBlocks[0].content;
}
/**
 * TODO: Add some auto-healing logic + extract YAML, JSON5, TOML, etc.
 * TODO: [🏢] Make this logic part of `JsonFormatDefinition` or `isValidJsonString`
 */

/**
 * @@@
 *
 * Note: `$` is used to indicate that this function is not a pure function - it mutates given object
 * Note: This function mutates the object and returns the original (but mutated-deep-freezed) object
 *
 * @returns The same object as the input, but deeply frozen
 * @public exported from `@promptbook/utils`
 */
function $deepFreeze(objectValue) {
    var e_1, _a;
    var propertyNames = Object.getOwnPropertyNames(objectValue);
    try {
        for (var propertyNames_1 = __values(propertyNames), propertyNames_1_1 = propertyNames_1.next(); !propertyNames_1_1.done; propertyNames_1_1 = propertyNames_1.next()) {
            var propertyName = propertyNames_1_1.value;
            var value = objectValue[propertyName];
            if (value && typeof value === 'object') {
                $deepFreeze(value);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (propertyNames_1_1 && !propertyNames_1_1.done && (_a = propertyNames_1.return)) _a.call(propertyNames_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return Object.freeze(objectValue);
}
/**
 * TODO: [🧠] Is there a way how to meaningfully test this utility
 */

/**
 * This error type indicates that the error should not happen and its last check before crashing with some other error
 *
 * @public exported from `@promptbook/core`
 */
var UnexpectedError = /** @class */ (function (_super) {
    __extends(UnexpectedError, _super);
    function UnexpectedError(message) {
        var _this = _super.call(this, spaceTrim$1(function (block) { return "\n                    ".concat(block(message), "\n\n                    Note: This error should not happen.\n                    It's probbably a bug in the pipeline collection\n\n                    Please report issue:\n                    https://github.com/webgptorg/promptbook/issues\n\n                    Or contact us on me@pavolhejny.com\n\n                "); })) || this;
        _this.name = 'UnexpectedError';
        Object.setPrototypeOf(_this, UnexpectedError.prototype);
        return _this;
    }
    return UnexpectedError;
}(Error));

/**
 * Checks if the value is [🚉] serializable as JSON
 * If not, throws an UnexpectedError with a rich error message and tracking
 *
 * - Almost all primitives are serializable BUT:
 * - `undefined` is not serializable
 * - `NaN` is not serializable
 * - Objects and arrays are serializable if all their properties are serializable
 * - Functions are not serializable
 * - Circular references are not serializable
 * - `Date` objects are not serializable
 * - `Map` and `Set` objects are not serializable
 * - `RegExp` objects are not serializable
 * - `Error` objects are not serializable
 * - `Symbol` objects are not serializable
 * - And much more...
 *
 * @throws UnexpectedError if the value is not serializable as JSON
 * @public exported from `@promptbook/utils`
 */
function checkSerializableAsJson(name, value) {
    var e_1, _a;
    if (value === undefined) {
        throw new UnexpectedError("".concat(name, " is undefined"));
    }
    else if (value === null) {
        return;
    }
    else if (typeof value === 'boolean') {
        return;
    }
    else if (typeof value === 'number' && !isNaN(value)) {
        return;
    }
    else if (typeof value === 'string') {
        return;
    }
    else if (typeof value === 'symbol') {
        throw new UnexpectedError("".concat(name, " is symbol"));
    }
    else if (typeof value === 'function') {
        throw new UnexpectedError("".concat(name, " is function"));
    }
    else if (typeof value === 'object' && Array.isArray(value)) {
        for (var i = 0; i < value.length; i++) {
            checkSerializableAsJson("".concat(name, "[").concat(i, "]"), value[i]);
        }
    }
    else if (typeof value === 'object') {
        if (value instanceof Date) {
            throw new UnexpectedError(spaceTrim("\n                    ".concat(name, " is Date\n\n                    Use `string_date_iso8601` instead\n                ")));
        }
        else if (value instanceof Map) {
            throw new UnexpectedError("".concat(name, " is Map"));
        }
        else if (value instanceof Set) {
            throw new UnexpectedError("".concat(name, " is Set"));
        }
        else if (value instanceof RegExp) {
            throw new UnexpectedError("".concat(name, " is RegExp"));
        }
        else if (value instanceof Error) {
            throw new UnexpectedError(spaceTrim("\n                    ".concat(name, " is unserialized Error\n\n                    Use function `serializeError`\n                ")));
        }
        else {
            try {
                for (var _b = __values(Object.entries(value)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var _d = __read(_c.value, 2), subName = _d[0], subValue = _d[1];
                    if (subValue === undefined) {
                        // Note: undefined in object is serializable - it is just omited
                        continue;
                    }
                    checkSerializableAsJson("".concat(name, ".").concat(subName), subValue);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            try {
                JSON.stringify(value); // <- TODO: [0]
            }
            catch (error) {
                if (!(error instanceof Error)) {
                    throw error;
                }
                throw new UnexpectedError(spaceTrim(function (block) { return "\n                            ".concat(name, " is not serializable\n\n                            ").concat(block(error.toString()), "\n                        "); }));
            }
            /*
            TODO: [0] Is there some more elegant way to check circular references?
            const seen = new Set();
            const stack = [{ value }];
            while (stack.length > 0) {
                const { value } = stack.pop()!;
                if (typeof value === 'object' && value !== null) {
                    if (seen.has(value)) {
                        throw new UnexpectedError(`${name} has circular reference`);
                    }
                    seen.add(value);
                    if (Array.isArray(value)) {
                        stack.push(...value.map((value) => ({ value })));
                    } else {
                        stack.push(...Object.values(value).map((value) => ({ value })));
                    }
                }
            }
            */
            return;
        }
    }
    else {
        throw new UnexpectedError("".concat(name, " is unknown"));
    }
}
/**
 * TODO: [🧠][🛣] More elegant way to tracking than passing `name`
 * TODO: [🧠][main] !!! In-memory cache of same values to prevent multiple checks
 * Note: [🐠] This is how `checkSerializableAsJson` + `isSerializableAsJson` together can just retun true/false or rich error message
 */

/**
 * @@@
 * @@@
 *
 * Note: This function mutates the object and returns the original (but mutated-deep-freezed) object
 *
 * @param name - Name of the object for debugging purposes
 * @param objectValue - Object to be deeply frozen
 * @returns The same object as the input, but deeply frozen
 * @private this is in comparison to `deepFreeze` a more specific utility and maybe not very good practice to use without specific reason and considerations
 */
function $asDeeplyFrozenSerializableJson(name, objectValue) {
    checkSerializableAsJson(name, objectValue);
    return $deepFreeze(objectValue);
}
/**
 * TODO: [🧠][🛣] More elegant way to tracking than passing `name`
 * TODO: [🧠] Is there a way how to meaningfully test this utility
 */

/**
 * Warning message for the generated sections and files files
 *
 * @private within the repository
 */
var GENERATOR_WARNING = "\u26A0\uFE0F WARNING: This code has been generated so that any manual changes will be overwritten";
/**
 * The names of the parameters that are reserved for special purposes
 *
 * @public exported from `@promptbook/core`
 */
$asDeeplyFrozenSerializableJson('RESERVED_PARAMETER_NAMES', [
    'content',
    'context',
    'knowledge',
    'samples',
    'modelName',
    'currentDate',
    // <- TODO: !!!!! list here all command names
    // <- TODO: Add more like 'date', 'modelName',...
    // <- TODO: Add [emoji] + instructions ACRY when adding new reserved parameter
]);
// <- TODO: [🧜‍♂️]
/**
 * @@@
 *
 * @public exported from `@promptbook/core`
 */
Object.freeze({
    delimiter: ',',
    quoteChar: '"',
    newline: '\n',
    skipEmptyLines: true,
});
/**
 * TODO: [🧠][🧜‍♂️] Maybe join remoteUrl and path into single value
 */

/**
 * Removes HTML or Markdown comments from a string.
 *
 * @param {string} content - The string to remove comments from.
 * @returns {string} The input string with all comments removed.
 * @public exported from `@promptbook/markdown-utils`
 */
function removeContentComments(content) {
    return spaceTrim$1(content.replace(/<!--(.*?)-->/gs, ''));
}

/**
 * Add or modify an auto-generated section in a markdown file
 *
 * @public exported from `@promptbook/markdown-utils`
 */
function addAutoGeneratedSection(content, options) {
    var sectionName = options.sectionName, sectionContent = options.sectionContent;
    var warningLine = "<!-- ".concat(GENERATOR_WARNING, " -->");
    var sectionRegex = new RegExp("<!--".concat(sectionName, "-->([\\s\\S]*?)<!--/").concat(sectionName, "-->"), 'g');
    var sectionMatch = content.match(sectionRegex);
    if (sectionMatch) {
        return content.replace(sectionRegex, spaceTrim$1(function (block) { return "\n                    <!--".concat(sectionName, "-->\n                    ").concat(block(warningLine), "\n                    ").concat(block(sectionContent), "\n                    <!--/").concat(sectionName, "-->\n                "); }));
    }
    var placeForSection = removeContentComments(content).match(/^##.*$/im);
    if (!placeForSection) {
        throw new ParseError(
        // <- [🧠] Maybe something better tha `ParseError`
        "No place where to put the section <!--".concat(sectionName, "-->"));
        // <- [🚞]
    }
    var _a = __read(placeForSection, 1), heading = _a[0];
    return content.replace(heading, "<!--".concat(sectionName, "-->\n").concat(warningLine, "\n").concat(sectionContent, "\n<!--/").concat(sectionName, "-->\n\n").concat(heading));
}
/**
 * TODO: [🏛] This can be part of markdown builder
 */

/**
 * Format either small or big number
 *
 * @private within the repository
 */
function formatNumber(value) {
    if (value === 0) {
        return '0';
    }
    for (var exponent = 0; exponent < 15; exponent++) {
        var factor = Math.pow(10, exponent);
        var valueRounded = Math.round(value * factor) / factor;
        if (Math.abs(value - valueRounded) / value <
            0.001 /* <- TODO: Pass as option, pass to executionReportJsonToString as option */) {
            return valueRounded.toFixed(exponent);
        }
    }
    return value.toString();
}

/**
 * Removes emojis from a string and fix whitespaces
 *
 * @param text with emojis
 * @returns text without emojis
 * @public exported from `@promptbook/utils`
 */
function removeEmojis(text) {
    // Replace emojis (and also ZWJ sequence) with hyphens
    text = text.replace(/(\p{Extended_Pictographic})\p{Modifier_Symbol}/gu, '$1');
    text = text.replace(/(\p{Extended_Pictographic})[\u{FE00}-\u{FE0F}]/gu, '$1');
    text = text.replace(/(\p{Extended_Pictographic})(\u{200D}\p{Extended_Pictographic})*/gu, '$1');
    text = text.replace(/\p{Extended_Pictographic}/gu, '');
    return text;
}

/**
 * Create a markdown table from a 2D array of strings
 *
 * @public exported from `@promptbook/markdown-utils`
 */
function createMarkdownTable(table) {
    var columnWidths = table.reduce(function (widths, row) {
        row.forEach(function (subformat, columnIndex) {
            var cellLength = subformat.length;
            if (!widths[columnIndex] || cellLength > widths[columnIndex]) {
                widths[columnIndex] = cellLength;
            }
        });
        return widths;
    }, []);
    var header = "| ".concat(table[0]
        .map(function (subformat, columnIndex) { return subformat.padEnd(columnWidths[columnIndex]); })
        .join(' | '), " |");
    var separator = "|".concat(columnWidths.map(function (width) { return '-'.repeat(width + 2); }).join('|'), "|");
    var rows = table.slice(1).map(function (row) {
        var paddedRow = row.map(function (subformat, columnIndex) {
            return subformat.padEnd(columnWidths[columnIndex]);
        });
        return "| ".concat(paddedRow.join(' | '), " |");
    });
    return __spreadArray([header, separator], __read(rows), false).join('\n');
}
/**
 * TODO: [🏛] This can be part of markdown builder
 */

/**
 * Function createMarkdownChart will draw a chart in markdown from ⬛+🟦 tiles
 *
 * @public exported from `@promptbook/markdown-utils`
 */
function createMarkdownChart(options) {
    var e_1, _a;
    var nameHeader = options.nameHeader, valueHeader = options.valueHeader, items = options.items, width = options.width, unitName = options.unitName;
    var from = Math.min.apply(Math, __spreadArray([], __read(items.map(function (item) { return item.from; })), false));
    var to = Math.max.apply(Math, __spreadArray([], __read(items.map(function (item) { return item.to; })), false));
    var scale = width / (to - from);
    var table = [[nameHeader, valueHeader]];
    try {
        for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
            var item = items_1_1.value;
            var before = Math.round((item.from - from) * scale);
            var during = Math.round((item.to - item.from) * scale);
            var after = width - before - during;
            table.push([removeEmojis(item.title).trim(), '░'.repeat(before) + '█'.repeat(during) + '░'.repeat(after)]);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (items_1_1 && !items_1_1.done && (_a = items_1.return)) _a.call(items_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var legend = "_Note: Each \u2588 represents ".concat(formatNumber(1 / scale), " ").concat(unitName, ", width of ").concat(valueHeader.toLowerCase(), " is ").concat(formatNumber(to - from), " ").concat(unitName, " = ").concat(width, " squares_");
    return createMarkdownTable(table) + '\n\n' + legend;
}
/**
 * TODO: Maybe use Mermain Gant Diagrams
 *       @see https://jojozhuang.github.io/tutorial/mermaid-cheat-sheet/
 */

/**
 * Function escapeMarkdownBlock will escape markdown block if needed
 * It is useful when you want have block in block
 *
 * @public exported from `@promptbook/markdown-utils`
 */
function escapeMarkdownBlock(value) {
    return value.replace(/```/g, '\\`\\`\\`');
}
/**
 * TODO: [🏛] This can be part of markdown builder
 */

/**
 * Utility function to extract all list items from markdown
 *
 * Note: It works with both ul and ol
 * Note: It omits list items in code blocks
 * Note: It flattens nested lists
 * Note: It can not work with html syntax and comments
 *
 * @param markdown any valid markdown
 * @returns @@@
 * @public exported from `@promptbook/markdown-utils`
 */
function extractAllListItemsFromMarkdown(markdown) {
    var e_1, _a;
    var lines = markdown.split('\n');
    var listItems = [];
    var isInCodeBlock = false;
    try {
        for (var lines_1 = __values(lines), lines_1_1 = lines_1.next(); !lines_1_1.done; lines_1_1 = lines_1.next()) {
            var line = lines_1_1.value;
            var trimmedLine = line.trim();
            if (trimmedLine.startsWith('```')) {
                isInCodeBlock = !isInCodeBlock;
            }
            if (!isInCodeBlock && (trimmedLine.startsWith('-') || trimmedLine.match(/^\d+\./))) {
                var listItem = trimmedLine.replace(/^-|\d+\./, '').trim();
                listItems.push(listItem);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (lines_1_1 && !lines_1_1.done && (_a = lines_1.return)) _a.call(lines_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return listItems;
}

/**
 * Parses markdown section to title its level and content
 *
 * @public exported from `@promptbook/markdown-utils`
 */
function parseMarkdownSection(value) {
    var _a, _b;
    var lines = value.split('\n');
    if (!lines[0].startsWith('#')) {
        throw new ParseError('Markdown section must start with heading');
    }
    var title = lines[0].replace(/^#+\s*/, '');
    var level = (_b = (_a = lines[0].match(/^#+/)) === null || _a === void 0 ? void 0 : _a[0].length) !== null && _b !== void 0 ? _b : 0;
    var content = spaceTrim(lines.slice(1).join('\n'));
    if (level < 1 || level > 6) {
        throw new ParseError('Markdown section must have heading level between 1 and 6');
    }
    return { title: title, level: level, content: content };
}
/**
 * Note: [🕞] In past (commit 42086e1603cbed506482997c00a8ee979af0a247) there was much more
 *       sophisticated implementation of this function through parsing markdown into JSON structure
 *       and flattening the actual structure
 *       NOW we are working just with markdown string and its good enough
 */

/**
 * Splits the markdown into sections by headings
 *
 * @public exported from `@promptbook/markdown-utils`
 */
function splitMarkdownIntoSections(markdown) {
    var e_1, _a;
    var lines = markdown.split('\n');
    var sections = [];
    var currentType = 'MARKDOWN';
    var buffer = [];
    var finishSection = function () {
        if (buffer.length === 0) {
            return;
        }
        var section = spaceTrim(buffer.join('\n'));
        if (section === '') {
            return;
        }
        if (!section.startsWith('#')) {
            section = "# Untitled\n\n".concat(section);
        }
        sections.push(section);
        buffer = [];
    };
    try {
        for (var lines_1 = __values(lines), lines_1_1 = lines_1.next(); !lines_1_1.done; lines_1_1 = lines_1.next()) {
            var line = lines_1_1.value;
            if (currentType === 'MARKDOWN') {
                if (line.startsWith('#')) {
                    finishSection();
                }
                buffer.push(line);
                if (line.startsWith('```')) {
                    currentType = 'CODE_BLOCK';
                }
                else if (line.includes('<!--')) {
                    currentType = 'COMMENT';
                }
            }
            else if (currentType === 'CODE_BLOCK') {
                buffer.push(line);
                if (line.startsWith('```')) {
                    currentType = 'MARKDOWN';
                }
            }
            else if (currentType === 'COMMENT') {
                buffer.push(line);
                if (line.includes('-->')) {
                    currentType = 'MARKDOWN';
                }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (lines_1_1 && !lines_1_1.done && (_a = lines_1.return)) _a.call(lines_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    finishSection();
    return sections;
}
/**
 * TODO: [🏛] This can be part of markdown builder
 * Note: [🕞] In past (commit 42086e1603cbed506482997c00a8ee979af0a247) there was much more
 *       sophisticated implementation of this function through parsing markdown into JSON structure
 *       and flattening the actual structure
 *       NOW we are working just with markdown string and its good enough
 */

/**
 * Normalizes the markdown by flattening the structure
 *
 * - It always have h1 - if there is no h1 in the markdown, it will be added "# Untitled"
 * - All other headings are normalized to h2
 *
 * @public exported from `@promptbook/markdown-utils`
 */
function flattenMarkdown(markdown) {
    var e_1, _a;
    var sections = splitMarkdownIntoSections(markdown);
    if (sections.length === 0) {
        return '# Untitled';
    }
    var flattenedMarkdown = '';
    var parsedSections = sections.map(parseMarkdownSection);
    var firstSection = parsedSections.shift();
    if (firstSection.level === 1) {
        flattenedMarkdown += "# ".concat(firstSection.title) + "\n\n";
        flattenedMarkdown += firstSection.content + "\n\n"; // <- [🧠] Maybe 3 new lines?
    }
    else {
        parsedSections.unshift(firstSection);
        flattenedMarkdown += "# Untitled" + "\n\n"; // <- [🧠] Maybe 3 new lines?
    }
    try {
        for (var parsedSections_1 = __values(parsedSections), parsedSections_1_1 = parsedSections_1.next(); !parsedSections_1_1.done; parsedSections_1_1 = parsedSections_1.next()) {
            var _b = parsedSections_1_1.value, title = _b.title, content = _b.content;
            flattenedMarkdown += "## ".concat(title) + "\n\n";
            flattenedMarkdown += content + "\n\n"; // <- [🧠] Maybe 3 new lines?
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (parsedSections_1_1 && !parsedSections_1_1.done && (_a = parsedSections_1.return)) _a.call(parsedSections_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return spaceTrim(flattenedMarkdown);
}
/**
 * TODO: [🏛] This can be part of markdown builder
 * Note: [🕞] In past (commit 42086e1603cbed506482997c00a8ee979af0a247) there was much more
 *       sophisticated implementation of this function through parsing markdown into JSON structure
 *       and flattening the actual structure
 *       NOW we are working just with markdown string and its good enough
 */

/**
 * Removes Markdown formatting tags from a string.
 *
 * @param {string} str - The string to remove Markdown tags from.
 * @returns {string} The input string with all Markdown tags removed.
 * @public exported from `@promptbook/markdown-utils`
 */
function removeMarkdownFormatting(str) {
    // Remove bold formatting
    str = str.replace(/\*\*(.*?)\*\*/g, '$1');
    // Remove italic formatting
    str = str.replace(/\*(.*?)\*/g, '$1');
    // Remove code formatting
    str = str.replace(/`(.*?)`/g, '$1');
    return str;
}

export { PROMPTBOOK_VERSION, addAutoGeneratedSection, createMarkdownChart, createMarkdownTable, escapeMarkdownBlock, extractAllBlocksFromMarkdown, extractAllListItemsFromMarkdown, extractBlock, extractJsonBlock, extractOneBlockFromMarkdown, flattenMarkdown, parseMarkdownSection, removeContentComments, removeMarkdownFormatting, splitMarkdownIntoSections };
//# sourceMappingURL=index.es.js.map
