/**
 * Represents the usage with no resources consumed
 *
 * @public exported from `@promptbook/core`
 */
export declare const ZERO_USAGE: import("type-fest/source/readonly-deep").ReadonlyObjectDeep<{
    readonly price: {
        readonly value: 0;
    };
    readonly input: {
        readonly tokensCount: {
            readonly value: 0;
        };
        readonly charactersCount: {
            readonly value: 0;
        };
        readonly wordsCount: {
            readonly value: 0;
        };
        readonly sentencesCount: {
            readonly value: 0;
        };
        readonly linesCount: {
            readonly value: 0;
        };
        readonly paragraphsCount: {
            readonly value: 0;
        };
        readonly pagesCount: {
            readonly value: 0;
        };
    };
    readonly output: {
        readonly tokensCount: {
            readonly value: 0;
        };
        readonly charactersCount: {
            readonly value: 0;
        };
        readonly wordsCount: {
            readonly value: 0;
        };
        readonly sentencesCount: {
            readonly value: 0;
        };
        readonly linesCount: {
            readonly value: 0;
        };
        readonly paragraphsCount: {
            readonly value: 0;
        };
        readonly pagesCount: {
            readonly value: 0;
        };
    };
}>;
/**
 * Represents the usage with unknown resources consumed
 *
 * @public exported from `@promptbook/core`
 */
export declare const UNCERTAIN_USAGE: import("type-fest/source/readonly-deep").ReadonlyObjectDeep<{
    readonly price: {
        readonly value: 0;
        readonly isUncertain: true;
    };
    readonly input: {
        readonly tokensCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly charactersCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly wordsCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly sentencesCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly linesCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly paragraphsCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly pagesCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
    };
    readonly output: {
        readonly tokensCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly charactersCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly wordsCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly sentencesCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly linesCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly paragraphsCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
        readonly pagesCount: {
            readonly value: 0;
            readonly isUncertain: true;
        };
    };
}>;
